package com.yeejoin.amos.boot.module.jg.biz.edit.process.biz.changeRegistrationUnit;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.yeejoin.amos.boot.biz.common.entity.BaseEntity;
import com.yeejoin.amos.boot.module.common.biz.event.CommonPublisher;
import com.yeejoin.amos.boot.module.jg.api.dto.FieldChangeMeta;
import com.yeejoin.amos.boot.module.jg.api.dto.PipelineChangeItemDto;
import com.yeejoin.amos.boot.module.jg.api.entity.JgChangeRegistrationUnit;
import com.yeejoin.amos.boot.module.jg.api.enums.BusinessTypeEnum;
import com.yeejoin.amos.boot.module.jg.biz.edit.event.BaseBizDataChangeEvent;
import com.yeejoin.amos.boot.module.jg.biz.edit.process.biz.DefaultBizDataChangeHandler;
import com.yeejoin.amos.boot.module.ymt.api.enums.FlowStatusEnum;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

import java.util.Collections;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * 单位变更登记编辑处理器
 */
@Component
public class ChangeRegistrationUnitDataChangeHandler extends DefaultBizDataChangeHandler<BaseBizDataChangeEvent> {

    private final ChangeRegistrationUnitEditUpdateService changeRegistrationUnitEditUpdateService;

    protected ChangeRegistrationUnitDataChangeHandler(CommonPublisher routerEventPublisher, ApplicationContext applicationContext, ChangeRegistrationUnitEditUpdateService changeRegistrationUnitEditUpdateService) {
        super(routerEventPublisher, applicationContext);
        this.changeRegistrationUnitEditUpdateService = changeRegistrationUnitEditUpdateService;
    }

    @Override
    public String canHandleBizType() {
        return BusinessTypeEnum.JG_COMPANY_CHANGE_REGISTRATION.name();
    }

    @Override
    public List<FieldChangeMeta> postSave(String bizId, String applyNo, ModelType model, Map<String, Object> changeData, List<FieldChangeMeta> allChangeColumns, Map<String, List<PipelineChangeItemDto>> pipelineChangeItemMap) {
        return Collections.emptyList();
    }

    /**
     * 管道专用
     * @param applyNo 单据号
     * 判断数据是实时落库，还是先存到json
     * @return 是否需要临时存储
     */
    @Override
    public Boolean requiresTemporarySave(String applyNo) {
        return false;
    }

    @Override
    public Boolean beforeCheck(String bizId, String applyNo, ModelType model, Map<String, Object> changeData) {
        return Boolean.TRUE;
    }

    @Override
    public Set<String> getEqs(String applyNo) {
        return changeRegistrationUnitEditUpdateService.getEqsByApplyNo(applyNo);
    }


    @Override
    public Boolean bizIsFinished(String applyNo) {
        JgChangeRegistrationUnit jgChangeRegistrationUnit = changeRegistrationUnitEditUpdateService.getMainService().getOne(new LambdaQueryWrapper<JgChangeRegistrationUnit>().eq(JgChangeRegistrationUnit::getApplyNo, applyNo).select(BaseEntity::getSequenceNbr, JgChangeRegistrationUnit::getStatus));
        return jgChangeRegistrationUnit.getStatus().equals(FlowStatusEnum.TO_BE_FINISHED.getName());
    }

    @Override
    public Set<String> getProjectContraptionIds(String applyNo) {
        Set<String> pIds = changeRegistrationUnitEditUpdateService.getProIdsByApplyNo(applyNo);
        pIds.remove(null);
        pIds.remove("");
        return pIds;
    }

    @Override
    public void preSave(String bizId, String applyNo, ModelType model, Map<String, Object> changeData) {

    }
}
